package md3.md3model;

/**
 * <p>Abstract superclass of all classes that represent objects that can
 * visit MD3Model objects according to the visitor pattern.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
public abstract class MD3ModelVisitor {
	
  /**
   * <p>Visit a MD3Model object.
   *
   * @param model The object to visit.
   */
  public abstract void visit(MD3Model model);
}