package md3.md3model;

import java.io.*;
import java.util.*;

/**
 * <p>Booch utility class that provides .skin file IO functions.
 *  
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
class SKINIO {
	
	private SKINIO() {} //cannot instantiate
	
	static void loadSkin(MD3Skin skin, InputStream in) throws IOException {
		BufferedReader bin=new BufferedReader(new InputStreamReader(in));
		
		//parse lines:
	  //meshname,texturename
	  String line=bin.readLine();
	  while (line!=null) {
	  	line=line.trim();
	  	
	  	StringTokenizer st=new StringTokenizer(line, ",\n\r");
	  	if (st.countTokens()==2) { //ignore lines with 0, 1 or more than 2 tokens
	  		String meshName=st.nextToken().trim();
	  		String textureName=st.nextToken().trim();
	  		
	  		MD3Texture tex=MD3ModelFactory.getFactory().makeMD3Texture(textureName, textureName);
	  		
	  		skin.putTexture(meshName, tex);
	  	}
	  	
	  	line=bin.readLine();
	  }	  
	}
	
}