package md3.md3view;

import java.io.*;

import md3.md3model.*;

import gl4java.*;

/**
 * <p>This class extends MD3Mesh objects with OpenGL specific state.
 *  
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
public class MD3GLMesh extends MD3Mesh {
  /**
   * <p>Source parameter to BlendFunc function.
   */
  public int GLSrcBlendFunc;
  
  /**
   * <p>Destination parameter to BlendFunc function.
   */
  public int GLDstBlendFunc;
  
  /**
   * <p>Parameter to DepthMask function.
   */
  public boolean GLDepthMask;
  
  protected MD3GLMesh(DataInput din) throws IOException {
  	super(din);

		//???can this test be changed -> where is the blending info????
  	if ((this.name.toLowerCase().indexOf("energy") != -1) ||
  		  (this.name.toLowerCase().indexOf("f_") != -1) ||
  		  (this.name.toLowerCase().indexOf("sphere") != -1) ||
  		  (this.name.toLowerCase().indexOf("flash") != -1)) {
  		//transparent mesh
  		GLSrcBlendFunc=GLEnum.GL_ONE;
  		GLDstBlendFunc=GLEnum.GL_ONE;
  		GLDepthMask=false; //GLEnum.GL_FALSE
  	}
  	else {
  		//opaque mesh
  		GLSrcBlendFunc=GLEnum.GL_ONE;
  		GLDstBlendFunc=GLEnum.GL_ZERO;
  		GLDepthMask=true; //GLEnum.GL_TRUE
  	}
  }
}