package md3.md3view;

import java.util.*;

import md3.md3model.*;

/**
 * <p>An MD3GLModel visitor that walks through a MD3GLModel structure and
 * refreshes (reloads from file) all texture data of the visited models.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */
public class MD3GLModelRefreshTextureVisitor extends MD3GLModelVisitor {			
	public void visit(MD3GLModel model) {
		for (int i=0;i<model.meshNum;i++) {
			MD3Mesh mesh=model.meshes[i];
			for (int j=0;j<mesh.textureNum;j++)
				if (mesh.textures[j]!=null)
					MD3GLModelFactory.refreshTexture(mesh.textures[j].loadFilename);
		}
		
    Iterator it=model.linkedModels();
    while (it.hasNext())
      ((MD3Model)it.next()).accept(this);		
	}	
}