package md3.md3view;

import md3.md3model.*;

/**
 * <p>Abstract superclass of all classes that represent objects that can
 * visit MD3GLModel objects. This class extends the normal MD3ModelVisitor
 * to alow it to only visit MD3GLModel objects that contain OpenGL
 * specific state.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */
public abstract class MD3GLModelVisitor extends MD3ModelVisitor {

  /**
   * <p>Visit a MD3GLModel object.
   *
   * @param model The object to visit.
   */
	public abstract void visit(MD3GLModel model);
	
	public void visit(MD3Model model) {
		if (! (model instanceof MD3GLModel))
			throw new RuntimeException("illegal visit");
		else
			visit((MD3GLModel)model);
	}
}