package md3.md3view;

import gl4java.*;

/**
 * <p>This class provides functionality to render a texture directely
 * on a GLCanvas.
 *  
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
public class MD3GLTextureRenderer {
	
	/**
	 * <p>Render the given texture on the given OpenGL canvas.
	 */
	public static void renderTexture(MD3GLCanvas canvas, MD3GLTexture tex) {
		GLFunc gl=canvas.getGL();
		
		float x=tex.width/8f;
		float z=tex.height/8f;
		
		gl.glBindTexture(GLEnum.GL_TEXTURE_2D, tex.bind);

		gl.glBegin(GLEnum.GL_QUADS);
		gl.glTexCoord2f(0.0f, 0.0f); 
		gl.glVertex3f(-x, 0.0f, z);
		gl.glTexCoord2f(1.0f, 0.0f); 
		gl.glVertex3f( x, 0.0f, z);
		gl.glTexCoord2f(1.0f, 1.0f); 
		gl.glVertex3f( x, 0.0f, -z);
		gl.glTexCoord2f(0.0f, 1.0f); 
		gl.glVertex3f(-x, 0.0f, -z);
		gl.glEnd();		
	}
}