package md3.md3view;

import java.util.*;

import md3.md3model.*;

/**
 * <p>An MD3GLModel visitor that walks through a MD3GLModel structure and
 * applies a given skin to the visited models.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */
public class MD3ModelApplySkinVisitor extends MD3ModelVisitor {
	private MD3Skin skin;
	
	/**
	 * <p>Create a new skin application visitor for the given skin.
	 */
	public MD3ModelApplySkinVisitor(MD3Skin skin) {
		this.skin=skin;
	}
	
	public void visit(MD3Model model) {
		for (int i=0;i<model.meshNum;i++) {
			MD3Mesh mesh=model.meshes[i];
			
			MD3Texture tex=skin.getTexture(mesh.name);			
			if (tex!=null)
				for (int j=0;j<mesh.textureNum;j++)
					mesh.textures[j]=tex;
		}
		
    Iterator it=model.linkedModels();
    while (it.hasNext())
      ((MD3Model)it.next()).accept(this);		
	}
}