package md3.md3view;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import md3.md3model.*;

/**
 * <p>An MD3Model visitor that walks through an MD3Model structure and updates
 * a detach menu with the names of the visited models.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */ 
public class MD3ModelUpdateDetachMenuVisitor extends MD3ModelVisitor {
	private Menu menu;
	
	/**
	 * <p>Create a new visitor that will update the given menu.
	 */
	public MD3ModelUpdateDetachMenuVisitor(Menu detachMenu) {
		this.menu=detachMenu;
		detachMenu.removeAll();	
	}
	
	public void visit(final MD3Model model) {
		MenuItem modelItem=new MenuItem(new java.io.File(model.loadFilename).getName());
		modelItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				MD3View.instance().detachModel(model);
        MD3View.instance().md3canvas.sDisplay();
			}
		});
		menu.add(modelItem);
		
    //visit children
    Iterator it=model.linkedModels();
    while (it.hasNext())
      ((MD3Model)it.next()).accept(this);		
	}
}