package md3.md3view;

import java.awt.*;
import java.awt.event.*;

/**
 * <p>This class implements the text viewer of the MD3View application.
 *  
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
public class MD3ViewTextViewer extends Frame {
	private TextArea textArea;
	
	/**
	 * <p>Create a new text viewer frame.
	 */
	public MD3ViewTextViewer() {
		super();
		
		this.setLayout(new BorderLayout());
		this.setIconImage(MD3View.instance().getIconImage());
		
		textArea=new TextArea();
		textArea.setEditable(false);
		this.add(textArea, BorderLayout.CENTER);

    this.addWindowListener( new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        MD3ViewTextViewer.this.setVisible(false);
      }
    });
    
		this.pack();
    this.setSize(350, 250);		
	}
	
	/**
	 * <p>Set the text that the viewer displays.
	 */
	public void setText(String text) {
		textArea.setText(text);
	}
}