package md3.util;

import java.io.*;

/**
 * <p>Booch utility class with usefull byte-level functions.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */ 
public final class ByteUtils {
	private ByteUtils() {} //cannot instantiate
	
  /**
   * <p>Return byte at position pos in integer i.
   */
  public static byte getByte(int i, int pos) {
    return (byte)((i >> (24-pos*8)) & 0x000000FF);
  }
  
  public static void copyAllBytes(InputStream source, OutputStream target) throws IOException {
    byte[] buf=new byte[1024];
    int len=0;
    while((len=source.read(buf)) > 0 )
    	target.write(buf, 0, len);
  }
}