package md3.util;

/**
 * <p>Booch utility class with matrix math operations.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be) 
 */ 
public final class MatrixMath {
	private MatrixMath() {} //cannot instantiate
  
  /**
   * <p>Float matrix multiplication.
   *
   * @return a*b or null if a and b have incompatible dimensions.
   */
  public static final float[][] mult(float[][] a, float[][] b) {
    float[][] res;

    if (a[0].length!=b.length)
      res=null;
    else {
      res=new float[a.length][b[0].length];
      for (int i=0;i<res.length;i++)
        for (int j=0;j<res[i].length;j++)
          for (int k=0;k<a[0].length;k++)
            res[i][j]+=a[i][k]*b[k][j];
    }

    return res;
  }  
}