package widgets.awt.event;

/**
 * <p>Event signaling the request for a popup menu to become visible
 * at a certain position.
 *
 * @author Erwin Vervaet (erwin@cs.kuleuven.ac.be)
 */
public class PopupMenuEvent extends java.util.EventObject {
	private int x, y;
	
	/**
	 * <p>Create a popup menu request event coming from a given source with
	 * a given location for the popup menu.
	 */
	public PopupMenuEvent(Object source, int x, int y) {
		super(source);
		
		this.x=x;
		this.y=y;
	}
	
	public int getX() {
		return x;
	}
	
	public int getY() {
		return y;
	}	
}